package org.modeshape.example.auth;

import org.modeshape.graph.ExecutionContext;
import org.modeshape.graph.SecurityContext;
import org.modeshape.graph.property.Path;
import org.modeshape.jcr.security.AuthorizationProvider;


/**
 * Used by {@link CustomAuthenticationProviderImpl}
 */
public class CustomSecurityContextImpl implements SecurityContext, AuthorizationProvider {

	public CustomSecurityContextImpl() {
		System.out.println("In constructor " + this.getClass().getName() );
	}

	/* (non-Javadoc)
	 * @see org.modeshape.jcr.security.AuthorizationProvider#hasPermission(org.modeshape.graph.ExecutionContext, java.lang.String, java.lang.String, java.lang.String, org.modeshape.graph.property.Path, java.lang.String[])
	 */
	public boolean hasPermission(ExecutionContext context, String repositoryName, String repositorySourceName, String workspaceName, Path path, String... actions) {

		System.out.println("hasPermission...");

		return true; // Default to true for everyone right now
	}

	/* (non-Javadoc)
	 * @see org.modeshape.graph.SecurityContext#getUserName()
	 */
	public String getUserName() {
		System.out.println("getUsername()...");

		return "some_user";
	}

	/* (non-Javadoc)
	 * @see org.modeshape.graph.SecurityContext#hasRole(java.lang.String)
	 */
	public boolean hasRole(String roleName) {
		System.out.println("hasRole? : " + roleName);

		return true; // Default to true for everyone right now
	}

	/* (non-Javadoc)
	 * @see org.modeshape.graph.SecurityContext#logout()
	 */
	public void logout() {
		System.out.println("logout");
	}

}
