package org.modeshape.example.auth;

import java.io.File;
import java.util.Set;

import javax.jcr.Session;

import org.modeshape.jcr.JcrConfiguration;
import org.modeshape.jcr.JcrEngine;
import org.modeshape.jcr.JcrRepository;
import org.modeshape.jcr.api.SecurityContextCredentials;

/* 
To run from command line:

> mvn install exec:java
  
*/
public class RunExample {

	public static void main(String[] args) throws Exception {

		File configFile = new File(RunExample.class.getResource("/modeshape_auth_config.xml").getPath());

		System.out.println("\n\nStart engine using config file : " + configFile + "\n");
		JcrConfiguration jcrConfig = new JcrConfiguration();
		JcrEngine engine = jcrConfig.loadFrom(configFile).build();
		
		System.out.println("> engine.start()");
		engine.start();

		System.out.println("> engine.getRepositoryNames()...");
		String repoName = null;
		Set<String> repositoryNames = engine.getRepositoryNames();
		for (String r : repositoryNames) {
			repoName = r;
			System.out.println("   '" + r + "'");
		}

		System.out.println("\n> engine.getRepository('" + repoName + "') ...\n");
		JcrRepository repo = engine.getRepository(repoName);
		
		System.out.println("\n> repo.login()\n");
		Session session = repo.login();

		System.out.println("Accessible workspaces:");
		String[] accessibleWorkspaceNames = session.getWorkspace().getAccessibleWorkspaceNames();

		for (String a : accessibleWorkspaceNames) {
			System.out.println(a);
		}

	}

}
